unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ImgList, ExtCtrls, Buttons, ComCtrls;

type
  TMainForm = class(TForm)
    LevelImages: TImageList;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    OutButton3A: TSpeedButton;
    OutButton3B: TSpeedButton;
    OutButton3C: TSpeedButton;
    OutButton1A: TSpeedButton;
    ReadTime: TTimer;
    TristateButton: TSpeedButton;
    BitLabelD7: TLabel;
    BitLabelD6: TLabel;
    BitLabelD5: TLabel;
    BitLabelD4: TLabel;
    BitLabelD3: TLabel;
    BitLabelD2: TLabel;
    BitLabelD1: TLabel;
    BitLabelD0: TLabel;
    OutButton1B: TSpeedButton;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    Image7: TImage;
    Image8: TImage;
    Image9: TImage;
    Image10: TImage;
    Image11: TImage;
    Image12: TImage;
    Image13: TImage;
    Image14: TImage;
    Image15: TImage;
    Image16: TImage;
    Image17: TImage;
    Image18: TImage;
    Image19: TImage;
    Image20: TImage;
    Image21: TImage;
    Image22: TImage;
    Image23: TImage;
    Image24: TImage;
    Image25: TImage;
    Image26: TImage;
    Image27: TImage;
    Image28: TImage;
    Image29: TImage;
    Image30: TImage;
    Image31: TImage;
    Image32: TImage;
    Image33: TImage;
    Image34: TImage;
    Image35: TImage;
    Image36: TImage;
    Image37: TImage;
    Image38: TImage;
    Image39: TImage;
    Image40: TImage;
    Image41: TImage;
    Image42: TImage;
    Image43: TImage;
    Image44: TImage;
    Image45: TImage;
    Image46: TImage;
    Image47: TImage;
    Image48: TImage;
    Image49: TImage;
    Image50: TImage;
    Image51: TImage;
    Image52: TImage;
    Image53: TImage;
    Image54: TImage;
    Image55: TImage;
    Image56: TImage;
    Image57: TImage;
    Image58: TImage;
    Image59: TImage;
    Image60: TImage;
    Image61: TImage;
    Image62: TImage;
    Image63: TImage;
    Image64: TImage;
    Image65: TImage;
    Image66: TImage;
    Image67: TImage;
    Image68: TImage;
    Image69: TImage;
    Image70: TImage;
    Image71: TImage;
    Image72: TImage;
    OutButton1C: TSpeedButton;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    Label42: TLabel;
    OutButton2A: TSpeedButton;
    OutButton2B: TSpeedButton;
    OutButton2C: TSpeedButton;
    Panel1: TPanel;
    Label1: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label68: TLabel;
    Label70: TLabel;
    Label71: TLabel;
    Label72: TLabel;
    Label73: TLabel;
    Label74: TLabel;
    Label75: TLabel;
    Label76: TLabel;
    Label77: TLabel;
    Label78: TLabel;
    Label79: TLabel;
    Label80: TLabel;
    Label81: TLabel;
    Label82: TLabel;
    Label83: TLabel;
    Label84: TLabel;
    Panel2: TPanel;
    Label26: TLabel;
    Label52: TLabel;
    Label53: TLabel;
    Label56: TLabel;
    Label57: TLabel;
    Label58: TLabel;
    Label59: TLabel;
    Label60: TLabel;
    Label69: TLabel;
    Label85: TLabel;
    Label86: TLabel;
    Label87: TLabel;
    Label88: TLabel;
    Label89: TLabel;
    Label90: TLabel;
    Label91: TLabel;
    Label92: TLabel;
    Label93: TLabel;
    Label94: TLabel;
    Label95: TLabel;
    Label96: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label27: TLabel;
    Panel5: TPanel;
    Label30: TLabel;
    debuglabel: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label43: TLabel;
    Panel3: TPanel;
    Label44: TLabel;
    Panel4: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure ReadTimeTimer(Sender: TObject);
    procedure LevelImageClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OutButtonClick(Sender: TObject);
    procedure TristateButtonClick(Sender: TObject);
  protected
  public
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses
  AIOUSB, DetectUnit;

var
  DeviceIndex: LongWord;
  LevelImage: array[0..95] of TImage;
  OutButton: array[0..11] of TSpeedButton;
  LowLevel, HighLevel: TBitmap;
  DIOData: array[0..11] of Byte;
  DoUpdate: Boolean;

function FormatFreq(Freq: Double): String;
begin
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  DetectForm: TDetectForm;
  OutMask: Word;
  I: Integer;
  Status: LongWord;

begin
  LowLevel := TBitmap.Create;
  HighLevel := TBitmap.Create;

  DeviceIndex := diOnly;

  OutMask := $0000;
  for I := 0 to 5 do DIOData[I] := $FF;
  for I := 6 to 8 do DIOData[I] := $00;
  Status := DIO_Configure(DeviceIndex, False, @OutMask, @DIOData);
  if Status <> ERROR_SUCCESS then begin
    DetectForm := TDetectForm.Create(Self);
    if DetectForm.ShowModal = mrOK then begin
      DeviceIndex := DetectForm.DeviceIndex;
      DetectForm.Free;
    end
    else begin
      DetectForm.Free;
      Application.Terminate;
      Exit;
    end;
    DIO_Configure(DeviceIndex, False, @OutMask, @DIOData);
  end;


  LevelImage[0] := Image25;
  LevelImage[1] := Image26;
  LevelImage[2] := Image27;
  LevelImage[3] := Image28;
  LevelImage[4] := Image29;
  LevelImage[5] := Image30;
  LevelImage[6] := Image31;
  LevelImage[7] := Image32;
  LevelImage[8] := Image33;
  LevelImage[9] := Image34;
  LevelImage[10] := Image35;
  LevelImage[11] := Image36;
  LevelImage[12] := Image37;
  LevelImage[13] := Image38;
  LevelImage[14] := Image39;
  LevelImage[15] := Image40;
  LevelImage[16] := Image41;
  LevelImage[17] := Image42;
  LevelImage[18] := Image43;
  LevelImage[19] := Image44;
  LevelImage[20] := Image45;
  LevelImage[21] := Image46;
  LevelImage[22] := Image47;
  LevelImage[23] := Image48;

  LevelImage[24] := Image49;
  LevelImage[25] := Image50;
  LevelImage[26] := Image51;
  LevelImage[27] := Image52;
  LevelImage[28] := Image53;
  LevelImage[29] := Image54;
  LevelImage[30] := Image55;
  LevelImage[31] := Image56;
  LevelImage[32] := Image57;
  LevelImage[33] := Image58;
  LevelImage[34] := Image59;
  LevelImage[35] := Image60;
  LevelImage[36] := Image61;
  LevelImage[37] := Image62;
  LevelImage[38] := Image63;
  LevelImage[39] := Image64;
  LevelImage[40] := Image65;
  LevelImage[41] := Image66;
  LevelImage[42] := Image67;
  LevelImage[43] := Image68;
  LevelImage[44] := Image69;
  LevelImage[45] := Image70;
  LevelImage[46] := Image71;
  LevelImage[47] := Image72;

  LevelImage[71] := Image1;
  LevelImage[70] := Image2;
  LevelImage[69] := Image3;
  LevelImage[68] := Image4;
  LevelImage[67] := Image5;
  LevelImage[66] := Image6;
  LevelImage[65] := Image7;
  LevelImage[64] := Image8;
  LevelImage[63] := Image9;
  LevelImage[62] := Image10;
  LevelImage[61] := Image11;
  LevelImage[60] := Image12;
  LevelImage[59] := Image13;
  LevelImage[58] := Image14;
  LevelImage[57] := Image15;
  LevelImage[56] := Image16;
  LevelImage[55] := Image17;
  LevelImage[54] := Image18;
  LevelImage[53] := Image19;
  LevelImage[52] := Image20;
  LevelImage[51] := Image21;
  LevelImage[50] := Image22;
  LevelImage[49] := Image23;
  LevelImage[48] := Image24;


  OutButton[ 0] := OutButton1A;
  OutButton[ 1] := OutButton1B;
  OutButton[ 2] := OutButton1C;
  OutButton[ 3] := OutButton2A;
  OutButton[ 4] := OutButton2B;
  OutButton[ 5] := OutButton2C;
  OutButton[ 6] := OutButton3A;
  OutButton[ 7] := OutButton3B;
  OutButton[ 8] := OutButton3C;


  LevelImages.GetBitmap(0, LowLevel);
  LevelImages.GetBitmap(1, HighLevel);

  DoUpdate := True;
  ReadTime.Enabled := True;
end;

procedure TMainForm.ReadTimeTimer(Sender: TObject);
var
  I: Integer;
  oDIODATA, Changes: array[0..11] of Byte;

begin
  for i:=0 to 8 do
  begin
    oDIOData[I] := DIOData[I];
  end;

  DIO_ReadAll(DeviceIndex, @DIOData[0]);

   debuglabel.caption := '';

  for i:=0 to 8 do
  begin
    Changes[I] := DIOData[I] xor oDIOData[I];
    debuglabel.caption := debuglabel.caption + IntToHex(DIOData[I],2);
  end;

  if DoUpdate then begin
    for i:=0 to 8 do
    begin
      Changes[I] := $FF;
    end;
    DoUpdate := False;
  end;

  for I := 0 to 71 do
    if (Changes[I div 8] and (1 shl (I mod 8))) <> 0 then
    begin
      if (DIOData[I div 8] and (1 shl (I mod 8))) <> 0 then
        LevelImage[I].Picture.Assign(HighLevel)
      else
        LevelImage[I].Picture.Assign(LowLevel)
    end
  ;
end;

procedure TMainForm.LevelImageClick(Sender: TObject);
var
  I: Integer;
  NewValue: Boolean;

begin
  I := (Sender as TImage).Tag;

  NewValue := ((DIOData[I div 8]) and (1 shl (I mod 8))) = 0; //Get bit value

  DIO_Write1(DeviceIndex, I, NewValue);

  DoUpdate := True;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  LowLevel.Free;
  HighLevel.Free;
end;

procedure TMainForm.OutButtonClick(Sender: TObject);
var
  I: Integer;
  OutMask: Word;

begin
  OutMask := $0000;
  for I := 0 to 5 do
    if OutButton[I].Down then
      OutMask := OutMask or (1 shl I)
  ;
  I := (Sender as TSpeedButton).Tag;
  DIOData[i] := $FF; //Set new output byte high, in case user made a mistake
  DIO_Configure(DeviceIndex, TristateButton.Down, @OutMask, @DIOData[0]);
  DoUpdate := True;
end;

procedure TMainForm.TristateButtonClick(Sender: TObject);
var
  I: Integer;
  OutMask: Word;

begin
  OutMask := $0000;
  for I := 0 to 5 do
    if OutButton[I].Down then
      OutMask := OutMask or (1 shl I)
  ;
  DIO_Configure(DeviceIndex, TristateButton.Down, @OutMask, @DIOData[0]);
end;

end.
